function [ outArray , indx] = StatArrayDiff1( array1, tm )
%input array of time indexes and tm time array
%return statiscs features of time intervals of 1 input array, and index of
%the "best" QRS complex
%output:
% outArray : statistics,
% indx index of the "best" QRS complex

outArray=zeros(1,11);
s0=tm(array1(1));
numqrs=0;
for k=2:length(array1)
    ctime=tm(array1(k))-s0;
    if ctime>6
        numqrs=k-1;
        break;
    end
end
heartbeats =10*numqrs;
timediff=tm(array1(length(array1)))-tm(array1(1));
timeall=60/timediff;
heartbeats2=length(array1)*timeall;

   % intervals=diff(tm(array1)); %calc time intervals
    intervals=diff((array1)); %calc  intervals
     rate=zeros(1,length(intervals)-1);
   for k=2:length(intervals)
        rate(k-1)=intervals(k)/intervals(k-1);
   end

 intervals=rate;
      intervals=sort(intervals);
%     quarter25=fix(length(intervals)/4);
%     quarter75=3*fix(length(intervals)/4);
    %remove  outlieres from left and right
    if length(intervals)>6
      intervals=intervals(2:length(intervals)-1);
    end
%     intervals=intervals(quarter25:quarter75);
    %R features
   st= std(intervals);
   mn=min(intervals);
   mx=max(intervals);
   avrg=mean(intervals);
    outArray(1)=mn;
    outArray(2)=mx;
    outArray(3)=avrg;
    outArray(4)=median(intervals);
    [md, freq]=mode(intervals);
    outArray(5)=md;
    outArray(6)=outArray(2)- outArray(1);
    outArray(7)=length(unique(intervals));
    
    if heartbeats >=60 && heartbeats<=100
        heartbeats=10;
    elseif heartbeats<60
        heartbeats=0;
    else
        heartbeats=20;
    end
    outArray(8)=heartbeats;
    
    if (heartbeats2<50)
        heartbeats2=0;
    elseif heartbeats2>100
        heartbeats2=20;
    else
        heartbeats2=10;
    end
    
    outArray(9)=heartbeats2;
    outArray(10)=st;
    %frequency of mode
    freq=freq^3;
    if freq>length(intervals)
        outArray(11)=1;
    else
        outArray(11)=freq/length(intervals);
    end
% % ctr68=0;
% % for k=1:length(intervals)
% %     if abs (intervals(k)-outArray(4)) <= st/2
% %         ctr68=ctr68+1;
% %     end
% % end
% outArray(11)=ctr68/length(intervals);
    %time categories intervals
    timediff=diff(tm(array1));
    md =median(timediff);
     %find the location of the mode
     indx=1;
     for kk=1:length(timediff);
         if md==timediff(kk)
             indx=kk;
             break;
         end
     end
%     outArray(11)=freq^2/length(timediff);
%     timediff=sort(timediff);
%     timediff=timediff(2:length(timediff)-1);
    
    newcats=TimeIntervalsPDF(timediff,0);
    Entropyvalue=Entropy1(newcats);
    uniformaty=sum(newcats.^2);
    %min to max intervals  ratio 
    mrate=mn/mx;
    outArray=[outArray mrate  newcats  Entropyvalue uniformaty  ];
end

